<template>
  <div class="row">
    <div class="columns four">
       <label for="lastName">Фамилия</label>
      <input
        type="text"
        name="lastName"
        v-model="$user.lastName"
        id="lastName"
        v-validate="'cyrillic|required|min:2|max:50'"
        :class="getValidateClass('lastName')"
        @input="input"
        autocomplete="off"
        data-code="lastNameTooShort, lastNameTooLong, lastNameInvalidFormat"
      />

      <validate-message v-show="vErrors.has('lastName')">
        {{ vErrors.first('lastName') }}
      </validate-message>

    </div>

    <div class="columns four">
      <label for="firstName">Имя</label>
      <input
        type="text"
        name="firstName"
        id="firstName"
        v-model="$user.firstName"
        v-validate="'required|cyrillic|min:2|max:50'"
        :class="getValidateClass('firstName')"
        @input="input"
        autocomplete="off"
        data-code="firstNameTooShort, firstNameTooLong, firstNameInvalidFormat"
      />

      <validate-message v-show="vErrors.has('firstName')">
        {{ vErrors.first('firstName') }}
      </validate-message>

    </div>

    <div class="columns four">
      <label for="middleName">Отчество</label>
      <input
        type="text"
        name="middleName"
        id="middleName"
        v-model="$user.middleName"
        v-validate="'required|cyrillic|min:2|max:50'"
        :class="getValidateClass('middleName')"
        @input="input"
        autocomplete="off"
        data-code="middleNameTooShort, middleNameTooLong, middleNameInvalidFormat"
      />

      <validate-message v-show="vErrors.has('middleName')">
        {{ vErrors.first('middleName') }}
      </validate-message>
    </div>

  </div>
</template>

<script>
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'

  export default {
    name: 'first-last-middle-name',
    components: {
      ValidateMessage
    },
    mixins: [
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
    },
    methods: {
      input ({target}) {

        this.$user.validate.step1.firstLastMiddleName = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)

      }
    }


  }
</script>

<style scoped lang="scss">
  .margin-top_-30 {
    margin-top: 30px;
  }

  .red {
    color: red;
  }

  .menu {
    display: none !important
  }
</style>
